struct module_fp_add_sub {
  _Bool isAdd;
  unsigned roundingMode;
  unsigned f;
  unsigned g;
  unsigned result;
  unsigned int uf_nan, uf_inf, uf_zero, uf_subnormal, uf_sign, uf_exponent, uf_significand;
  unsigned int ug_nan, ug_inf, ug_zero, ug_subnormal, ug_sign;

};

extern struct module_fp_add_sub fp_add_sub;

void set_inputs(void);

int main()
{
  float f, g;
  float C_result, Verilog_result;
   
  // sync the inputs
  fp_add_sub.f=*(unsigned *)&f;
  fp_add_sub.g=*(unsigned *)&g;
  fp_add_sub.isAdd=1;
  fp_add_sub.roundingMode=0;
 
  // partition constraint 
  __CPROVER_assume(!(fp_add_sub.uf_nan && fp_add_sub.uf_inf && fp_add_sub.uf_zero && fp_add_sub.uf_subnormal));
  __CPROVER_assume(!(fp_add_sub.ug_nan && fp_add_sub.ug_inf && fp_add_sub.ug_zero && fp_add_sub.ug_subnormal));
/*
  __CPROVER_assume(!fp_add_sub.uf_nan && !fp_add_sub.uf_inf && !fp_add_sub.uf_zero && !fp_add_sub.uf_subnormal);
  __CPROVER_assume(!fp_add_sub.ug_nan && !fp_add_sub.ug_inf && !fp_add_sub.ug_zero && !fp_add_sub.ug_subnormal);
*/  
  set_inputs();
  
  // Compute Verilog result
  Verilog_result=*(float *)&fp_add_sub.result;
  
  // Compute C result
  C_result = f+g;
  
  // check the output
  assert(compareFloat(C_result, Verilog_result));
}
